/*
  Top 10, a racing simulator
  Copyright (C) 2003,2005  Johann Deneux
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  Authors can be contacted at following electronic addresses:
  Johann Deneux: johann.deneux@it.uu.se
*/

#ifndef TOP10_GRAPHXWIRENODE_HH
#define TOP10_GRAPHXWIRENODE_HH

#include "LeafNode.hh"
#include "math/Box.hh"

#include <list>

namespace top10 {
namespace graphX {

class WireNode: public LeafNode {
public:
  void addWire(const top10::math::Vector& v1, const top10::math::Vector& v2);
  void renderGL(const RenderingFeatures&, const RenderState&, const CameraNode&) const;

  static WireNode* makeBox(const top10::math::AxisAlignedBox&);

private:
  std::list< std::pair <top10::math::Vector, top10::math::Vector> > wires;
};

}
}

#endif
